## linglong 1.7.4

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

cmake_minimum_required(VERSION 3.11.4)

project(
  linglong
  VERSION 1.6.1
  DESCRIPTION "a container based application package manager for Linux desktop"
  HOMEPAGE_URL "https://github.com/OpenAtom-Linyaps/linyaps"
  LANGUAGES CXX)

set(LINGLONG_VERSION
    ""
    CACHE STRING "The version of linglong project.")

if(NOT ("${LINGLONG_VERSION}" STREQUAL ""))
  message(STATUS "Project version has been overridden to ${LINGLONG_VERSION}")
  set(PROJECT_VERSION ${LINGLONG_VERSION})
endif()

set(ENABLE_UAB
    OFF
    CACHE BOOL "enable building UAB")
set(ENABLE_LINGLONG_INSTALLER
    OFF
    CACHE BOOL "enable linglong installer")

set(ENABLE_TESTING
    ON
    CACHE BOOL "enable testing")

set(LINGLONG_USERNAME
    "deepin-linglong"
    CACHE STRING "The username for linglong package manager")
set(LINGLONG_ROOT
    "/var/lib/linglong"
    CACHE STRING "The location where linglong related program puts their data")
set(LINGLONG_DEFAULT_OCI_RUNTIME
    "ll-box"
    CACHE STRING "The oci runtime which linglong use by default")

set(LINGLONG_CLI_BIN
    "ll-cli"
    CACHE STRING "The client of package management.")
set(GETTEXT_DOMAIN_NAME
    "linyaps"
    CACHE STRING "The name of gettext domain.")
set(QT_VERSION_MAJOR
    5
    CACHE STRING "The major version of qt.")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(PFL)

if(${QT_VERSION_MAJOR} EQUAL 6)
  include(Qt6DBusMacro)
endif()

set(ENABLE_CPM YES)

if(CMAKE_VERSION VERSION_LESS "3.14")
  set(ENABLE_CPM NO)
  message(
    STATUS "cmake version ${CMAKE_VERSION} not compatible with CPM.cmake.")
endif()

if(CPM_LOCAL_PACKAGES_ONLY)
  set(ENABLE_CPM NO)
endif()

if(ENABLE_CPM)
  include(CPM)
  CPMFindPackage(
    NAME tl-expected
    VERSION 1.0.0 # NOTE: Upstream cmake version doesn't match git tag, we need
                  # https://github.com/TartanLlama/expected/pull/62 in v1.1.0,
                  # but cmake version of v1.1.0 is 1.0.0.
    GITHUB_REPOSITORY TartanLlama/expected
    GIT_TAG v1.1.0
    GIT_SHALLOW ON
    OPTIONS "EXPECTED_BUILD_TESTS OFF"
    EXCLUDE_FROM_ALL ON)
  CPMFindPackage(
    NAME yaml-cpp
    VERSION 0.6.2
    GITHUB_REPOSITORY jbeder/yaml-cpp
    GIT_TAG 0.8.0 # NOTE: When use this project with CPM.cmake(FetchContent), we
                  # need https://github.com/jbeder/yaml-cpp/pull/583 in v0.8.0
    EXCLUDE_FROM_ALL ON
    OPTIONS "YAML_CPP_INSTALL ON" "YAML_CPP_BUILD_TESTS OFF")
  CPMFindPackage(
    NAME nlohmann_json
    VERSION 3.5.0
    URL "https://github.com/nlohmann/json/archive/refs/tags/v3.5.0.tar.gz"
    EXCLUDE_FROM_ALL ON
    OPTIONS "JSON_BuildTests OFF")
  CPMFindPackage(
    NAME CLI11
    VERSION 2.4.1
    GITHUB_REPOSITORY CLIUtils/CLI11
    GIT_TAG v2.4.1
    EXCLUDE_FROM_ALL ON
    OPTIONS "CLI11_BUILD_TESTS OFF")

  if(ENABLE_TESTING)
    include(CTest)
    CPMFindPackage(
      NAME googletest
      GITHUB_REPOSITORY google/googletest
      GIT_TAG v1.14.0
      VERSION 1.12.1
      OPTIONS "INSTALL_GTEST OFF" "gtest_force_shared_crt"
      FIND_PACKAGE_ARGUMENTS "NAMES GTest"
      GIT_SHALLOW ON
      EXCLUDE_FROM_ALL ON)
  endif()
endif()

set(linglong_EXTERNALS "ytj ytj::ytj")

# NOTE: UOS v20 do not have tl-expected packaged.
find_package(tl-expected 1.0.0 QUIET)
if(NOT tl-expected_FOUND)
  # list(APPEND linglong_EXTERNALS tl-expected) # tl-expected requires 3.14
  add_library(tl-expected INTERFACE)
  add_library(tl::expected ALIAS tl-expected)
  target_include_directories(tl-expected
                             INTERFACE ./external/tl-expected/include)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake.external)
endif()

find_package(nlohmann_json 3.5.0 QUIET)
if(NOT nlohmann_json_FOUND)
  list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake.fix)
  find_package(nlohmann_json 3.5.0 REQUIRED)
endif()

# NOTE: UOS v20 do not have cli11 packaged.
find_package(CLI11 2.4.1 QUIET)
if(NOT CLI11_FOUND)
  list(APPEND linglong_EXTERNALS "CLI11 CLI11::CLI11")
endif()

find_package(PkgConfig REQUIRED)

if(ENABLE_TESTING)
  pkg_search_module(CRYPTO REQUIRED IMPORTED_TARGET libcrypto)
  find_package(GTest REQUIRED)

  # compatible with old gtest
  if(NOT TARGET GTest::gmock)
    message(STATUS "GTest::gmock not found, alias GTest::gtest")
    add_library(GTest::gmock ALIAS GTest::GTest) # available since 3.5
  endif()
endif()

function(get_real_target_name output target)
  get_target_property("${output}" "${target}" ALIASED_TARGET)
  if("${output}" STREQUAL "")
    set("${output}" "${target}")
  endif()
  set("${output}"
      ${${output}}
      PARENT_SCOPE)
endfunction()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# NOTE(black_desk): Qt keywords conflict with glib.
add_definitions("-DQT_NO_KEYWORDS")

# NOTE(black_desk): Enable Qt logging with context.
add_definitions("-DQT_MESSAGELOGCONTEXT")

# We need to support both Qt5 and Qt6, and according to the Qt documentation, we
# should be using versioned targets and functions. These varible must be set
# before find_package()
# https://doc.qt.io/qt-6/cmake-qt5-and-qt6-compatibility.html#recommended-practices
set(QT_DEFAULT_MAJOR_VERSION ${QT_VERSION_MAJOR})
set(QT_NO_CREATE_VERSIONLESS_FUNCTIONS ON)
set(QT_NO_CREATE_VERSIONLESS_TARGETS ON)

find_package(
  Qt${QT_VERSION_MAJOR}
  COMPONENTS Core DBus
  REQUIRED)

pkg_search_module(glib2 REQUIRED IMPORTED_TARGET glib-2.0)
pkg_search_module(ostree1 REQUIRED IMPORTED_TARGET ostree-1)
pkg_search_module(systemd REQUIRED IMPORTED_TARGET libsystemd)
pkg_search_module(ELF REQUIRED IMPORTED_TARGET libelf)

set(ytj_ENABLE_TESTING NO)
set(ytj_ENABLE_INSTALL NO)

pfl_init(AUTO)

add_subdirectory(external/http)
add_subdirectory(tools/qdbusxml2cpp)

include(GNUInstallDirs)

pfl_add_libraries(
  LIBS
  api
  dbus-api
  utils
  ocppi
  linglong
  APPS
  generators/00-id-mapping
  generators/05-initialize
  generators/20-devices
  generators/25-host-env
  generators/30-user-home
  generators/40-host-ipc
  generators/90-legacy
  ll-box
  ll-builder
  ll-cli
  ll-package-manager
  llpkg
  uab
  ll-session-helper)

add_subdirectory(misc)
add_subdirectory(po)

=== misc/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

include(GNUInstallDirs)

function(configure_files)
  foreach(input ${ARGV})
    configure_file(${input} ${input} @ONLY)
  endforeach()
endfunction()

configure_files(
  # find -regex '\.\/\(script\|share\|lib\|libexec\)\/.*' -type f -printf '%P\n'
  # | sort
  libexec/linglong/app-conf-generator
  libexec/linglong/builder/helper/config-check.sh
  libexec/linglong/builder/helper/ldd-check.sh
  libexec/linglong/builder/helper/main-check.sh
  libexec/linglong/builder/helper/symbols-strip.sh
  libexec/linglong/fetch-archive-source
  libexec/linglong/fetch-dsc-source
  libexec/linglong/fetch-file-source
  libexec/linglong/fetch-git-source
  lib/linglong/container/config.d/10-basics.json
  lib/linglong/container/config.d/25-host-rootfs.json
  lib/linglong/container/config.d/25-host-statics.json
  lib/linglong/container/config.json
  lib/linglong/container/README.md
  lib/linglong/generate-xdg-data-dirs.sh
  lib/systemd/system-environment-generators/61-linglong
  lib/systemd/system/org.deepin.linglong.PackageManager.service
  lib/systemd/system-preset/91-linglong.preset
  lib/systemd/user/linglong-session-helper.service
  lib/sysusers.d/linglong.conf
  lib/tmpfiles.d/linglong.conf
  script/linglong.sh
  share/bash-completion/completions/ll-builder
  share/bash-completion/completions/ll-cli
  share/dbus-1/system.d/org.deepin.linglong.PackageManager1.conf
  share/dbus-1/system-services/org.deepin.linglong.PackageManager1.service
  share/linglong/builder/templates/example.yaml
  share/linglong/config.yaml
  share/mime/packages/vnd.linyaps.uab.xml
  share/polkit-1/actions/org.deepin.linglong.PackageManager1.policy)

# bash-completion
set(BASH_COMPLETIONS_DIR ${CMAKE_INSTALL_DATADIR}/bash-completion)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/bash-completion/completions
        DESTINATION ${BASH_COMPLETIONS_DIR})

# dbus
set(DBUS_SYSTEM_BUS_DIR ${CMAKE_INSTALL_DATADIR}/dbus-1)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/dbus-1/system.d
        DESTINATION ${DBUS_SYSTEM_BUS_DIR})
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/dbus-1/system-services
        DESTINATION ${DBUS_SYSTEM_BUS_DIR})

# libexec
set(LIBEXEC_LINGLONG_DIR ${CMAKE_INSTALL_PREFIX}/libexec/linglong)
install(
  PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/app-conf-generator
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/fetch-archive-source
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/fetch-dsc-source
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/fetch-file-source
           ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/fetch-git-source
  DESTINATION ${LIBEXEC_LINGLONG_DIR})

# builder helpers
set(LIBEXEC_LINGLONG_BUILDER_DIR ${LIBEXEC_LINGLONG_DIR}/builder/helper)
install(
  PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/builder/helper/config-check.sh
    ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/builder/helper/ldd-check.sh
    ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/builder/helper/main-check.sh
    ${CMAKE_CURRENT_BINARY_DIR}/libexec/linglong/builder/helper/symbols-strip.sh
  DESTINATION ${LIBEXEC_LINGLONG_BUILDER_DIR})

# linglong
set(LINGLONG_CONFIG_DIR
    ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/config.d)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/00-id-mapping-static
     ${LINGLONG_CONFIG_DIR}/00-id-mapping SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/05-initialize-static
     ${LINGLONG_CONFIG_DIR}/05-initialize SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/20-devices-static
     ${LINGLONG_CONFIG_DIR}/20-devices SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/25-host-env-static
     ${LINGLONG_CONFIG_DIR}/25-host-env SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/30-user-home-static
     ${LINGLONG_CONFIG_DIR}/30-user-home SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/40-host-ipc-static
     ${LINGLONG_CONFIG_DIR}/40-host-ipc SYMBOLIC)
file(CREATE_LINK ${CMAKE_INSTALL_PREFIX}/libexec/linglong/90-legacy-static
     ${LINGLONG_CONFIG_DIR}/90-legacy SYMBOLIC)

install(
  PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/generate-xdg-data-dirs.sh
  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/linglong)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/config.json
              ${CMAKE_CURRENT_BINARY_DIR}/lib/linglong/container/README.md
        DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/linglong/container)

install(
  FILES ${LINGLONG_CONFIG_DIR}/10-basics.json
        ${LINGLONG_CONFIG_DIR}/25-host-rootfs.json
        ${LINGLONG_CONFIG_DIR}/25-host-statics.json
        ${LINGLONG_CONFIG_DIR}/00-id-mapping
        ${LINGLONG_CONFIG_DIR}/05-initialize
        ${LINGLONG_CONFIG_DIR}/20-devices
        ${LINGLONG_CONFIG_DIR}/25-host-env
        ${LINGLONG_CONFIG_DIR}/30-user-home
        ${LINGLONG_CONFIG_DIR}/40-host-ipc
        ${LINGLONG_CONFIG_DIR}/90-legacy
  DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/linglong/container/config.d)

# linglong default configuration
install(FILES ${CMAKE_CURRENT_LIST_DIR}/share/linglong/config.yaml
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/linglong)

# builder templates
install(DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/share/linglong/builder/templates/
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/linglong/builder/templates)

# systemd
set(SYSTEMD_SYSTEM_PRESET_PATH
    ${CMAKE_INSTALL_PREFIX}/lib/systemd/system-preset)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/system-preset/
        DESTINATION ${SYSTEMD_SYSTEM_PRESET_PATH})

set(SYSTEMD_SYSTEM_UNIT_PATH ${CMAKE_INSTALL_PREFIX}/lib/systemd)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/system
        DESTINATION ${SYSTEMD_SYSTEM_UNIT_PATH})

set(SYSTEMD_USER_UNIT_PATH ${CMAKE_INSTALL_PREFIX}/lib/systemd)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/user
        DESTINATION ${SYSTEMD_USER_UNIT_PATH})

set(SYSTEMD_SYSTEM_GENERATOR_PATH
    ${CMAKE_INSTALL_PREFIX}/lib/systemd/system-environment-generators)

install(
  PROGRAMS
    ${CMAKE_CURRENT_BINARY_DIR}/lib/systemd/system-environment-generators/61-linglong
  DESTINATION ${SYSTEMD_SYSTEM_GENERATOR_PATH})

# sysuser

set(SYSTEMD_SYSUSERSDIR ${CMAKE_INSTALL_PREFIX}/lib/sysusers.d)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/sysusers.d/
        DESTINATION ${SYSTEMD_SYSUSERSDIR})

# tmpfiles
set(SYSTEMD_TMPFILESDIR ${CMAKE_INSTALL_PREFIX}/lib/tmpfiles.d)
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/lib/tmpfiles.d/
        DESTINATION ${SYSTEMD_TMPFILESDIR})

# xdg
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/share/mime/packages
        DESTINATION ${CMAKE_INSTALL_DATADIR}/mime)

# set linglong XDG_DATA_DIRS environtment
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/script/linglong.sh
        DESTINATION /etc/profile.d)

install(
  FILES ${CMAKE_CURRENT_BINARY_DIR}/script/linglong.sh
  DESTINATION /etc/X11/Xsession.d/
  RENAME 21linglong)

# polkit actions
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/share/polkit-1/actions/org.deepin.linglong.PackageManager1.policy
  DESTINATION ${CMAKE_INSTALL_DATADIR}/polkit-1/actions)

=== po/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (C) 2018 Xiphos Development Team
#
# SPDX-License-Identifier: GPL-2.0-or-later

# building MO files We copy all PO files in the build dir in order to not alter
# the source tree as 'gettext_process_pot_file' rebuilds each PO file from the
# POT file. The only case a PO file is created is when a language is set in
# LINGUAS and the PO file is missing.

find_package(Gettext)

if(GETTEXT_FOUND)
  # # get a list of active translations from LINGUAS
  file(READ ${CMAKE_CURRENT_SOURCE_DIR}/LINGUAS linguas)
  # # transform linguas string to a cmake regular list
  string(REGEX MATCHALL "[a-zA-Z_]+" langs "${linguas}")

  # copy PO files into build dir
  foreach(lang ${langs})
    set(pofile "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po")
    if(NOT EXISTS ${pofile})
      # missing PO, add a new PO file
      message(STATUS "Creating po/${lang}.po from LINGUAS.")
      # copy linyaps.pot into build dir
      file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/${GETTEXT_DOMAIN_NAME}.pot"
           DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
      # rename pot copy to ${lang}.po
      file(RENAME "${CMAKE_CURRENT_BINARY_DIR}/${GETTEXT_DOMAIN_NAME}.pot"
           "${CMAKE_CURRENT_BINARY_DIR}/${lang}.po")
      # copy new ${lang}.po into source dir
      file(COPY "${CMAKE_CURRENT_BINARY_DIR}/${lang}.po"
           DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
    else()
      # copy existing PO file into build dir
      file(COPY "${CMAKE_CURRENT_SOURCE_DIR}/${lang}.po"
           DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
    endif()
  endforeach(lang)

  # create and install MO files
  gettext_process_pot_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/${GETTEXT_DOMAIN_NAME}.pot ALL
    INSTALL_DESTINATION ${CMAKE_INSTALL_LOCALEDIR}
    LANGUAGES ${langs})

  add_custom_target(process-pot-file)
  get_real_target_name(TARGET linglong::ll-cli)
  get_real_target_name(BUILD_TARGET linglong::ll-builder)
  add_dependencies("${TARGET}" process-pot-file)
  add_dependencies("${BUILD_TARGET}" process-pot-file)

  # Custom targets for updating translation files NOTE: these targets will
  # update files in the source tree

  # target to refresh POT file
  find_program(INTLTOOL_UPDATE intltool-update)
  add_custom_target(
    pot
    COMMAND ${INTLTOOL_UPDATE} --pot --gettext-package=${GETTEXT_DOMAIN_NAME}
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po
    COMMENT "Updating pot file.")

  # target for updating a given PO file
  foreach(language ${langs})
    add_custom_target(
      linyaps_${language}.po
      COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE} --update --verbose ${language}.po
              ${GETTEXT_DOMAIN_NAME}.pot
      WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po
      COMMENT "Updating ${language}.po file")

    # prepare command for the all PO target
    set(PO_UPDATE_ALL
        ${PO_UPDATE_ALL}
        &&
        echo
        ${language}.po:
        &&
        ${GETTEXT_MSGMERGE_EXECUTABLE}
        --update
        --verbose
        ${language}.po
        ${GETTEXT_DOMAIN_NAME}.pot)
  endforeach()

  # target for updating all PO files
  set(PO_UPDATE_ALL pwd ${PO_UPDATE_ALL})
  add_custom_target(
    po
    COMMAND ${PO_UPDATE_ALL}
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}/po
    COMMENT "Updating all PO files"
    VERBATIM)
endif()

=== external/http/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6...3.10.2)
project (LinglongRepoClientAPI)

cmake_policy(SET CMP0063 NEW)

set(CMAKE_C_VISIBILITY_PRESET default)
set(CMAKE_CXX_VISIBILITY_PRESET default)
set(CMAKE_VISIBILITY_INLINES_HIDDEN OFF)
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

option(BUILD_SHARED_LIBS "Build using shared libraries" OFF)

find_package(OpenSSL)

if (OPENSSL_FOUND)
    message (STATUS "OPENSSL found")

    set(CMAKE_C_FLAGS "-DOPENSSL")
    if(CMAKE_VERSION VERSION_LESS 3.4)
        include_directories(${OPENSSL_INCLUDE_DIR})
        include_directories(${OPENSSL_INCLUDE_DIRS})
        link_directories(${OPENSSL_LIBRARIES})
    endif()

    message(STATUS "Using OpenSSL ${OPENSSL_VERSION}")
else()
    message (STATUS "OpenSSL Not found.")
endif()

set(pkgName LinglongRepoClientAPI)

# this default version can be overridden in PreTarget.cmake
set(PROJECT_VERSION_MAJOR 0)
set(PROJECT_VERSION_MINOR 0)
set(PROJECT_VERSION_PATCH 1)

if( (DEFINED CURL_INCLUDE_DIR) AND (DEFINED CURL_LIBRARIES))
    include_directories(${CURL_INCLUDE_DIR})
    set(PLATFORM_LIBRARIES ${PLATFORM_LIBRARIES} ${CURL_LIBRARIES} )
else()
    find_package(CURL 7.58.0 REQUIRED)
    if(CURL_FOUND)
        include_directories(${CURL_INCLUDE_DIR})
        set(PLATFORM_LIBRARIES ${PLATFORM_LIBRARIES} ${CURL_LIBRARIES} )
    else(CURL_FOUND)
        message(FATAL_ERROR "Could not find the CURL library and development files.")
    endif()
endif()

set(SRCS
    src/list.c
    src/apiKey.c
    src/apiClient.c
    src/binary.c
    external/cJSON.c
    model/object.c
    model/api_json_result.c
    model/api_upload_task_file_resp.c
    model/api_upload_task_layer_file_resp.c
    model/fuzzy_search_app_200_response.c
    model/get_repo_200_response.c
    model/new_upload_task_id_200_response.c
    model/request_auth.c
    model/request_fuzzy_search_req.c
    model/request_register_struct.c
    model/response_new_upload_task_resp.c
    model/response_sign_in.c
    model/response_upload_task_resp.c
    model/response_upload_task_status_info.c
    model/schema_new_upload_task_req.c
    model/schema_repo_info.c
    model/sign_in_200_response.c
    model/upload_task_info_200_response.c
    api/ClientAPI.c

)

set(HDRS
    include/apiClient.h
    include/list.h
    include/binary.h
    include/keyValuePair.h
    external/cJSON.h
    model/object.h
    model/api_json_result.h
    model/api_upload_task_file_resp.h
    model/api_upload_task_layer_file_resp.h
    model/fuzzy_search_app_200_response.h
    model/get_repo_200_response.h
    model/new_upload_task_id_200_response.h
    model/request_auth.h
    model/request_fuzzy_search_req.h
    model/request_register_struct.h
    model/response_new_upload_task_resp.h
    model/response_sign_in.h
    model/response_upload_task_resp.h
    model/response_upload_task_status_info.h
    model/schema_new_upload_task_req.h
    model/schema_repo_info.h
    model/sign_in_200_response.h
    model/upload_task_info_200_response.h
    api/ClientAPI.h

)

include(PreTarget.cmake OPTIONAL)

set(PROJECT_VERSION_STRING "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}")

# Add library with project file with project name as library name
add_library(${pkgName} ${SRCS} ${HDRS})
# Link dependent libraries
if(NOT CMAKE_VERSION VERSION_LESS 3.4)
    target_link_libraries(${pkgName} PRIVATE OpenSSL::SSL OpenSSL::Crypto)
endif()
target_link_libraries(${pkgName} PUBLIC ${CURL_LIBRARIES} )
target_include_directories(
    ${pkgName} PUBLIC $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>
)

include(PostTarget.cmake OPTIONAL)

# make installation packages
include(Packing.cmake OPTIONAL)

# Setting file variables to null
set(SRCS "")
set(HDRS "")


## This section shows how to use the above compiled library to compile the source files
## set source files
#set(SRCS
#    unit-tests/manual-ClientAPI.c
#)

##set header files
#set(HDRS
#)

## loop over all files in SRCS variable
#foreach(SOURCE_FILE ${SRCS})
#    # Get only the file name from the file as add_executable does not support executable with slash("/")
#    get_filename_component(FILE_NAME_ONLY ${SOURCE_FILE} NAME_WE)
#    # Remove .c from the file name and set it as executable name
#    string( REPLACE ".c" "" EXECUTABLE_FILE ${FILE_NAME_ONLY})
#    # Add executable for every source file in  SRCS
#    add_executable(unit-${EXECUTABLE_FILE} ${SOURCE_FILE})
#    # Link above created library to executable and dependent library curl
#    target_link_libraries(unit-${EXECUTABLE_FILE} ${CURL_LIBRARIES} ${pkgName} )
#endforeach(SOURCE_FILE ${SRCS})

=== libs/api/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  # find -regex '\.\/.+\.[ch]\(pp\)?' -type f -printf '%P\n'| sort
  src/linglong/api/types/helper.cpp
  src/linglong/api/types/helper.h
  src/linglong/api/types/v1/ApplicationConfiguration.hpp
  src/linglong/api/types/v1/ApplicationConfigurationPermissionsBind.hpp
  src/linglong/api/types/v1/ApplicationConfigurationPermissions.hpp
  src/linglong/api/types/v1/ApplicationConfigurationPermissionsInnerBind.hpp
  src/linglong/api/types/v1/BuilderConfig.hpp
  src/linglong/api/types/v1/BuilderProject.hpp
  src/linglong/api/types/v1/BuilderProjectPackage.hpp
  src/linglong/api/types/v1/BuilderProjectSource.hpp
  src/linglong/api/types/v1/CliContainer.hpp
  src/linglong/api/types/v1/CommonResult.hpp
  src/linglong/api/types/v1/Generators.hpp
  src/linglong/api/types/v1/helper.hpp
  src/linglong/api/types/v1/InteractionReply.hpp
  src/linglong/api/types/v1/InteractionRequest.hpp
  src/linglong/api/types/v1/LayerInfo.hpp
  src/linglong/api/types/v1/LinglongAPIV1.hpp
  src/linglong/api/types/v1/OciConfigurationPatch.hpp
  src/linglong/api/types/v1/PackageInfo.hpp
  src/linglong/api/types/v1/PackageInfoV2.hpp
  src/linglong/api/types/v1/PackageManager1GetRepoInfoResult.hpp
  src/linglong/api/types/v1/PackageManager1GetRepoInfoResultRepoInfo.hpp
  src/linglong/api/types/v1/PackageManager1InstallParameters.hpp
  src/linglong/api/types/v1/PackageManager1JobInfo.hpp
  src/linglong/api/types/v1/PackageManager1ModifyRepoParameters.hpp
  src/linglong/api/types/v1/PackageManager1Package.hpp
  src/linglong/api/types/v1/PackageManager1PackageTaskResult.hpp
  src/linglong/api/types/v1/PackageManager1SearchParameters.hpp
  src/linglong/api/types/v1/PackageManager1SearchResult.hpp
  src/linglong/api/types/v1/PackageManager1UninstallParameters.hpp
  src/linglong/api/types/v1/PackageManager1UpdateParameters.hpp
  src/linglong/api/types/v1/RepoConfig.hpp
  src/linglong/api/types/v1/RepositoryCache.hpp
  src/linglong/api/types/v1/RepositoryCacheLayersItem.hpp
  src/linglong/api/types/v1/Sections.hpp
  src/linglong/api/types/v1/State.hpp
  src/linglong/api/types/v1/SubState.hpp
  src/linglong/api/types/v1/UabLayer.hpp
  src/linglong/api/types/v1/UabMetaInfo.hpp
  src/linglong/api/types/v1/Version.hpp
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  nlohmann_json::nlohmann_json)

=== libs/linglong/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  src/linglong/builder/builder_releases.qrc
  # find -regex '\./src/.+\.[ch]\(pp\)?\(\.in\)?' -type f -printf '%P\n'| sort
  src/linglong/adaptors/package_manager/package_manager1.cpp
  src/linglong/adaptors/package_manager/package_manager1.h
  src/linglong/adaptors/task/task1.cpp
  src/linglong/adaptors/task/task1.h
  src/linglong/builder/config.cpp
  src/linglong/builder/config.h
  src/linglong/builder/linglong_builder.cpp
  src/linglong/builder/linglong_builder.h
  src/linglong/builder/printer.h
  src/linglong/builder/source_fetcher.cpp
  src/linglong/builder/source_fetcher.h
  src/linglong/cli/cli.cpp
  src/linglong/cli/cli.h
  src/linglong/cli/cli_printer.cpp
  src/linglong/cli/cli_printer.h
  src/linglong/cli/dbus_notifier.cpp
  src/linglong/cli/dbus_notifier.h
  src/linglong/cli/dummy_notifier.cpp
  src/linglong/cli/dummy_notifier.h
  src/linglong/cli/interactive_notifier.h
  src/linglong/cli/json_printer.cpp
  src/linglong/cli/json_printer.h
  src/linglong/cli/printer.h
  src/linglong/cli/terminal_notifier.cpp
  src/linglong/cli/terminal_notifier.h
  src/linglong/package/architecture.cpp
  src/linglong/package/architecture.h
  src/linglong/package/fuzzy_reference.cpp
  src/linglong/package/fuzzy_reference.h
  src/linglong/package/layer_dir.cpp
  src/linglong/package/layer_dir.h
  src/linglong/package/layer_file.cpp
  src/linglong/package/layer_file.h
  src/linglong/package/layer_packager.cpp
  src/linglong/package/layer_packager.h
  src/linglong/package_manager/package_manager.cpp
  src/linglong/package_manager/package_manager.h
  src/linglong/package_manager/package_task.cpp
  src/linglong/package_manager/package_task.h
  src/linglong/package/reference.cpp
  src/linglong/package/reference.h
  src/linglong/package/uab_file.cpp
  src/linglong/package/uab_file.h
  src/linglong/package/uab_packager.cpp
  src/linglong/package/uab_packager.h
  src/linglong/package/version.cpp
  src/linglong/package/version.h
  src/linglong/package/version_range.cpp
  src/linglong/package/version_range.h
  src/linglong/repo/client_factory.cpp
  src/linglong/repo/client_factory.h
  src/linglong/repo/config.cpp
  src/linglong/repo/config.h
  src/linglong/repo/migrate.cpp
  src/linglong/repo/migrate.h
  src/linglong/repo/ostree_repo.cpp
  src/linglong/repo/ostree_repo.h
  src/linglong/repo/repo_cache.cpp
  src/linglong/repo/repo_cache.h
  src/linglong/runtime/container_builder.cpp
  src/linglong/runtime/container_builder.h
  src/linglong/runtime/container.cpp
  src/linglong/runtime/container.h
  # FIXME(black_desk): After refactory, all tests are failed to compile as I
  # have no time to fix them now. Let's bring them back later. TESTS ll-tests
  # http-client-tests
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  pthread
  linglong::dbus-api
  linglong::utils
  linglong::api
  PkgConfig::ostree1
  PkgConfig::systemd
  PkgConfig::ELF
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::DBus
  LinglongRepoClientAPI
  ytj::ytj
  tl::expected
  linglong::ocppi
  CLI11::CLI11
  ${YAML_CPP})

function(
  linglong_add_dbus_adaptor
  target
  xml
  includes
  parent_class
  basename
  classname)
  get_real_target_name(target ${target})

  set(DBUS_ADAPTOR_SOURCE)

  if(${QT_VERSION_MAJOR} EQUAL 6)
    qt6_add_dbus_adaptor_override(
      qdbusxml2cpp
      DBUS_ADAPTOR_SOURCE
      ${xml}
      ${includes}
      ${parent_class}
      ${basename}
      ${classname})
  else()
    set(Qt5DBus_QDBUSXML2CPP_EXECUTABLE qdbusxml2cpp) # this varible only exists
                                                      # in qt5
    qt5_add_dbus_adaptor(DBUS_ADAPTOR_SOURCE ${xml} ${includes} ${parent_class}
                         ${basename} ${classname})
  endif()
  # FIXME(black_desk): `qt5_add_dbus_adaptor` will use basename as include and
  # this cannot be configured at all. This is just a workaround.
  target_include_directories(${target} PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
  target_sources(${target} PRIVATE ${DBUS_ADAPTOR_SOURCE})
endfunction()

linglong_add_dbus_adaptor(
  linglong::linglong
  ${PROJECT_SOURCE_DIR}/api/dbus/org.deepin.linglong.PackageManager1.xml
  linglong/package_manager/package_manager.h
  linglong::service::PackageManager
  src/linglong/adaptors/package_manager/gen_org_deepin_linglong_packagemanager1
  OrgDeepinLinglongPackagemanager1Adaptor)

linglong_add_dbus_adaptor(
  linglong::linglong
  ${PROJECT_SOURCE_DIR}/api/dbus/org.deepin.linglong.Task1.xml
  linglong/package_manager/package_task.h
  linglong::service::PackageTask
  src/linglong/adaptors/task/gen_org_deepin_linglong_task1
  OrgDeepinLinglongTask1Adaptor)

=== libs/utils/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

pfl_add_library(
  MERGED_HEADER_PLACEMENT
  DISABLE_INSTALL
  LIBRARY_TYPE
  STATIC
  SOURCES
  # find -regex '\.\/*.+\.[ch]\(pp\)?\(.in\)?' -type f -printf '%P\n'| sort
  src/linglong/utils/command/env.cpp
  src/linglong/utils/command/env.h
  src/linglong/utils/command/ocppi-helper.cpp
  src/linglong/utils/command/ocppi-helper.h
  src/linglong/utils/configure.cpp
  src/linglong/utils/configure.h.in
  src/linglong/utils/dbus/log.cpp
  src/linglong/utils/dbus/log.h
  src/linglong/utils/dbus/properties_forwarder.cpp
  src/linglong/utils/dbus/properties_forwarder.h
  src/linglong/utils/dbus/register.cpp
  src/linglong/utils/dbus/register.h
  src/linglong/utils/error/details/error_impl.cpp
  src/linglong/utils/error/details/error_impl.h
  src/linglong/utils/error/error.cpp
  src/linglong/utils/error/error.h
  src/linglong/utils/finally/finally.cpp
  src/linglong/utils/finally/finally.h
  src/linglong/utils/global/initialize.cpp
  src/linglong/utils/global/initialize.h
  src/linglong/utils/packageinfo_handler.cpp
  src/linglong/utils/packageinfo_handler.h
  src/linglong/utils/serialize/json.cpp
  src/linglong/utils/serialize/json.h
  src/linglong/utils/serialize/yaml.cpp
  src/linglong/utils/serialize/yaml.h
  src/linglong/utils/std_helper/qdebug_helper.h
  src/linglong/utils/transaction.cpp
  src/linglong/utils/transaction.h
  src/linglong/utils/xdg/desktop_entry.cpp
  src/linglong/utils/xdg/desktop_entry.h
  src/linglong/utils/gettext.h
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PUBLIC
  Qt${QT_VERSION_MAJOR}::Core
  Qt${QT_VERSION_MAJOR}::DBus
  PkgConfig::glib2
  tl::expected
  ytj::ytj
  linglong::ocppi
  linglong::api)

=== apps/generators/30-user-home/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

add_link_options(-static -static-libgcc -static-libstdc++)

pfl_add_executable(
  OUTPUT_NAME
  30-user-home-static
  LIBEXEC
  linglong
  SOURCES
  src/main.cpp
  LINK_LIBRARIES
  PRIVATE
  linglong::api
  nlohmann_json::nlohmann_json
  stdc++fs)

=== apps/uab/header/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")

# TODO: if erofsfuse and libdeflate provides .pc file or config.cmake, change it
# to pkg_search_modules/find_package

find_library(FOUND_erofsfuse_STATIC "erofsfuse")
if("${FOUND_erofsfuse_STATIC}" STREQUAL "")
  message(FATAL_ERROR "liberofsfuse.a not found")
endif()

get_filename_component(EROFSFUSE_ABS_FILE ${FOUND_erofsfuse_STATIC} ABSOLUTE)
message(STATUS "found liberofsfuse.a: ${ABS_FILE}")

find_library(FOUND_libdeflate_STATIC "deflate")
if("${FOUND_libdeflate_STATIC}" STREQUAL "")
  message(FATAL_ERROR "libdeflate.a not found")
endif()

get_filename_component(LIBDEFLATE_ABS_FILE ${FOUND_libdeflate_STATIC} ABSOLUTE)
message(STATUS "found libdeflate.a: ${LIBDEFLATE_ABS_FILE}")

pkg_search_module(elf_static REQUIRED IMPORTED_TARGET libelf)
pkg_search_module(lz4 REQUIRED IMPORTED_TARGET liblz4)
pkg_search_module(lzma REQUIRED IMPORTED_TARGET liblzma)
pkg_search_module(ZLIB REQUIRED IMPORTED_TARGET zlib)
pkg_search_module(ZSTD REQUIRED IMPORTED_TARGET libzstd)
pkg_search_module(FUSE REQUIRED IMPORTED_TARGET fuse)
pkg_search_module(SELINUX REQUIRED IMPORTED_TARGET libselinux)

target_link_libraries(PkgConfig::SELINUX INTERFACE ${SELINUX_STATIC_LIBRARIES})
target_link_libraries(PkgConfig::FUSE INTERFACE ${FUSE_STATIC_LIBRARIES})

pfl_add_executable(
  DISABLE_INSTALL
  SOURCES
  ./src/main.cpp
  ./src/sha256.h
  OUTPUT_NAME
  uab-header
  LINK_LIBRARIES
  PRIVATE
  linglong::api
  nlohmann_json::nlohmann_json
  PkgConfig::SELINUX
  PkgConfig::elf_static
  PkgConfig::lz4
  PkgConfig::lzma
  PkgConfig::ZLIB
  PkgConfig::ZSTD
  PkgConfig::FUSE
  ${EROFSFUSE_ABS_FILE}
  ${LIBDEFLATE_ABS_FILE}
  stdc++fs)

set(UAB_HEADER_TARGET)
get_real_target_name(UAB_HEADER_TARGET linglong::header)

target_link_options(${UAB_HEADER_TARGET} PRIVATE -static -static-libgcc
                    -static-libstdc++)

if(${AGGRESSIVE_UAB_SIZE})
  target_compile_options(
    ${UAB_HEADER_TARGET} PRIVATE -Os -fno-asynchronous-unwind-tables -fno-rtti
                                 -fdata-sections -ffunction-sections -flto=auto)

  target_link_options(
    ${UAB_HEADER_TARGET} PRIVATE
    -Wl,--gc-sections,--strip-all,--exclude-libs,ALL -flto=auto)
endif()

include(GNUInstallDirs)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/uab-header
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/linglong/builder/uab)

=== libs/linglong/tests/http-client-tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

find_package(
  Qt${QT_VERSION_MAJOR}
  COMPONENTS Test
  REQUIRED)

pfl_add_executable(
  OUTPUT_NAME
  http_client_tests
  DISABLE_INSTALL
  SOURCES
  src/ostree_repo_test.cpp
  src/repo_client_test.cpp
  src/mock-network.h
  src/mock-network.cpp
  LINK_LIBRARIES
  PRIVATE
  Qt${QT_VERSION_MAJOR}::Test
  linglong::linglong)

add_test(NAME http_client_tests COMMAND http_client_tests)

=== libs/linglong/tests/ll-tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: LGPL-3.0-or-later

CPMFindPackage(
  NAME googletest
  GITHUB_REPOSITORY google/googletest
  GIT_TAG v1.14.0
  VERSION 1.12.1
  OPTIONS "INSTALL_GTEST OFF" "gtest_force_shared_crt"
  FIND_PACKAGE_ARGUMENTS "NAMES GTest"
  GIT_SHALLOW ON
  EXCLUDE_FROM_ALL ON)

pfl_add_executable(
  OUTPUT_NAME
  ll-tests
  DISABLE_INSTALL
  SOURCES
  # find -regex '\./src/.+\.[ch]\(pp\)?' -type f -printf '%P\n'| sort
  src/linglong/api/dbus/v1/mock_app_manager.h
  src/linglong/api/dbus/v1/mock_package_manager.h
  src/linglong/cli/cli_test.cpp
  src/linglong/cli/dbus_reply.h
  src/linglong/cli/mock_app_manager.h
  src/linglong/cli/mock_printer.h
  src/linglong/package_manager/mock_package_manager.h
  src/linglong/package/reference_test.cpp
  src/linglong/package/version_range_test.cpp
  src/linglong/package/version_test.cpp
  src/linglong/repo/ostree_repo_test.cpp
  src/linglong/utils/error/result_test.cpp
  src/linglong/utils/sha256_test.cpp
  src/linglong/utils/transaction_test.cpp
  src/linglong/utils/xdg/desktop_entry_test.cpp
  src/main.cpp
  COMPILE_FEATURES
  PUBLIC
  cxx_std_17
  LINK_LIBRARIES
  PRIVATE
  GTest::gmock
  linglong::linglong
  PkgConfig::CRYPTO
  Qt${QT_VERSION_MAJOR}::DBusPrivate)

include(GoogleTest)
get_real_target_name(tests linglong::linglong::ll_tests)
gtest_discover_tests(${tests} WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR})

# FIXME: we should'n include header directly
target_include_directories(${tests}
                           PUBLIC ${PROJECT_SOURCE_DIR}/apps/uab/header/src)

=== debian/changelog ===
linglong (1.7.4-1) unstable; urgency=medium

  * fix: old version of ll-cli cannot export the new package
  * fix: incorrect official website display in the DTK About dialog
  * refactor: no need to pullDependency during ll-builder run
  * fix: abnormal cursor size in wayland
  * fix: PM blocked in a cancled task

 -- dengbo <dengbo@deepin.org>  Wed, 18 Dec 2024 16:20:06 +0800

linglong (1.7.3-1) unstable; urgency=medium

  * release 1.7.3-1

 -- dengbo <dengbo@deepin.org>  Tue, 10 Dec 2024 19:22:29 +0800

linglong (1.7.2-1) unstable; urgency=medium

  * release 1.7.2-1

 -- dengbo <dengbo@deepin.org>  Wed, 04 Dec 2024 17:39:49 +0800

linglong (1.7.1-1) unstable; urgency=medium

  * release 1.7.1-1

 -- dengbo <dengbo@deepin.org>  Fri, 29 Nov 2024 11:28:30 +0800

linglong (1.7.0-1) unstable; urgency=medium

  * release 1.7.0-1

 -- dengbo <dengbo@deepin.org>  Fri, 01 Nov 2024 11:06:45 +0800

=== debian/control ===
Source: linglong
Section: admin
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: cmake,
               debhelper-compat (= 12),
               erofsfuse,
               intltool,
               libcli11-dev (>= 2.4.1) | hello,
               libcurl4-openssl-dev,
               libdeflate-dev,
               libelf-dev,
               libexpected-dev (>= 1.0.0~dfsg-2~bpo10+1) | hello,
               libfuse-dev,
               libglib2.0-dev,
               libgmock-dev,
               libgtest-dev,
               liblz4-dev,
               liblzma-dev,
               libostree-dev,
               libpcre2-dev,
               libseccomp-dev,
               libselinux1-dev,
               libssl-dev,
               libsystemd-dev,
               libyaml-cpp-dev (>= 0.6.2),
               libzstd-dev,
               nlohmann-json3-dev (>= 3.5.0),
               pkg-config,
               qt5-qmake,
               qtbase5-dev,
               qtbase5-private-dev,
               systemd,
               zlib1g-dev
Standards-Version: 4.1.3
Homepage: http://www.deepin.org

Package: linglong-bin
Architecture: any
Depends: desktop-file-utils,
         erofsfuse,
         libglib2.0-bin,
         linglong-box | crun,
         shared-mime-info,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: linglong-dbus-proxy
Conflicts: linglong-dbus-proxy
Description: Linglong package manager.
 Linglong package management command line tool.

Package: linglong-builder
Architecture: any
Depends: erofs-utils,
         erofsfuse,
         git,
         linglong-bin,
         linglong-box | crun,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: devscripts, linglong-loader
Description: Linglong application building tools.
 ll-builder is a tool that makes it easy to build applications and dependencies.

Package: linglong-box
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Deepin sandbox with OCI standard.
 Deepin sandbox...
